> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mobilerun.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Device fingerprint snapshot

> Returns a live snapshot of the device's spoofed identity, including model, display, identifiers, and carrier. Devices without fingerprint support return an unsupported-feature error.



## OpenAPI

````yaml /api-reference/phones/tools.yaml get /devices/{deviceId}/fingerprint
openapi: 3.1.0
info:
  title: Tools
  version: v1
servers:
  - url: https://api.mobilerun.ai
    description: Droidrun Cloud API
security:
  - bearerAuth: []
paths:
  /devices/{deviceId}/fingerprint:
    get:
      tags:
        - Misc
      summary: Device fingerprint snapshot
      description: >-
        Returns a live snapshot of the device's spoofed identity, including
        model, display, identifiers, and carrier. Devices without fingerprint
        support return an unsupported-feature error.
      operationId: device-fingerprint
      parameters:
        - in: path
          name: deviceId
          required: true
          schema:
            type: string
        - in: header
          name: X-Device-Display-ID
          schema:
            default: 0
            format: int64
            minimum: 0
            type: integer
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/FingerprintResult'
          description: OK
        default:
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ErrorModel'
          description: Error
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Mobilerun from '@mobilerun/sdk';

            const client = new Mobilerun({
              apiKey: process.env['MOBILERUN_CLOUD_API_KEY'], // This is the default and can be omitted
            });

            const response = await client.devices.fingerprint('deviceId');

            console.log(response.identifiers);
        - lang: Python
          source: |-
            import os
            from mobilerun_sdk import Mobilerun

            client = Mobilerun(
                api_key=os.environ.get("MOBILERUN_CLOUD_API_KEY"),  # This is the default and can be omitted
            )
            response = client.devices.fingerprint(
                device_id="deviceId",
            )
            print(response.identifiers)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/stainless-sdks/droidrun-cloud-go\"\n\t\"github.com/stainless-sdks/droidrun-cloud-go/option\"\n)\n\nfunc main() {\n\tclient := mobileruncloud.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tresponse, err := client.Devices.Fingerprint(\n\t\tcontext.TODO(),\n\t\t\"deviceId\",\n\t\tmobileruncloud.DeviceFingerprintParams{},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", response.Identifiers)\n}\n"
        - lang: CLI
          source: |-
            mobilerun-cloud devices fingerprint \
              --api-key 'My API Key' \
              --device-id deviceId
components:
  schemas:
    FingerprintResult:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/FingerprintResult.json
          format: uri
          readOnly: true
          type: string
        carrier:
          $ref: '#/components/schemas/DeviceCarrier'
        display:
          $ref: '#/components/schemas/FingerprintDisplay'
        identifiers:
          $ref: '#/components/schemas/DeviceIdentifiers'
        model:
          $ref: '#/components/schemas/FingerprintModel'
      required:
        - model
        - display
        - identifiers
        - carrier
      type: object
    ErrorModel:
      additionalProperties: false
      properties:
        $schema:
          description: A URL to the JSON Schema for this object.
          examples:
            - https://example.com/schemas/ErrorModel.json
          format: uri
          readOnly: true
          type: string
        detail:
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem.
          examples:
            - Property foo is required but is missing.
          type: string
        errors:
          description: Optional list of individual error details
          items:
            $ref: '#/components/schemas/ErrorDetail'
          type:
            - array
            - 'null'
        instance:
          description: >-
            A URI reference that identifies the specific occurrence of the
            problem.
          examples:
            - https://example.com/error-log/abc123
          format: uri
          type: string
        status:
          description: HTTP status code
          examples:
            - 400
          format: int64
          type: integer
        title:
          description: >-
            A short, human-readable summary of the problem type. This value
            should not change between occurrences of the error.
          examples:
            - Bad Request
          type: string
        type:
          default: about:blank
          description: A URI reference to human-readable documentation for the error.
          examples:
            - https://example.com/errors/example
          format: uri
          type: string
      type: object
    DeviceCarrier:
      additionalProperties: false
      properties:
        GsmOperatorAlpha:
          type: string
        GsmOperatorNumeric:
          format: int64
          type: integer
        GsmSimOperatorAlpha:
          type: string
        GsmSimOperatorIsoCountry:
          type: string
        GsmSimOperatorNumeric:
          format: int64
          type: integer
        PersistSysTimezone:
          type: string
      required:
        - GsmOperatorAlpha
        - GsmOperatorNumeric
        - GsmSimOperatorAlpha
        - GsmSimOperatorNumeric
        - GsmSimOperatorIsoCountry
        - PersistSysTimezone
      type: object
    FingerprintDisplay:
      additionalProperties: false
      properties:
        densityDpi:
          format: int64
          type: integer
        height:
          format: int64
          type: integer
        width:
          format: int64
          type: integer
      type: object
    DeviceIdentifiers:
      additionalProperties: false
      properties:
        BootloaderSerialNumber:
          type: string
        IdentifierAndroidID:
          type: string
        IdentifierAppSetID:
          type: string
        IdentifierBluetoothMAC:
          type: string
        IdentifierGAID:
          type: string
        IdentifierGSFID:
          type: string
        IdentifierICCID:
          type: string
        IdentifierIMEI:
          type: string
        IdentifierIMSI:
          type: string
        IdentifierMEID:
          type: string
        IdentifierMediaDRMID:
          type: string
        IdentifierPhoneNumber:
          type: string
        IdentifierSerial:
          type: string
        IdentifierWifiMAC:
          type: string
        SerialNumber:
          type: string
      required:
        - IdentifierSerial
        - IdentifierAndroidID
        - IdentifierIMEI
        - IdentifierMEID
        - IdentifierIMSI
        - IdentifierICCID
        - IdentifierPhoneNumber
        - IdentifierGAID
        - IdentifierGSFID
        - IdentifierAppSetID
        - IdentifierMediaDRMID
        - IdentifierWifiMAC
        - IdentifierBluetoothMAC
        - SerialNumber
        - BootloaderSerialNumber
      type: object
    FingerprintModel:
      additionalProperties: false
      properties:
        aospVersion:
          type: string
        brand:
          type: string
        device:
          type: string
        hardware:
          type: string
        imageRepository:
          type: string
        manufacturer:
          type: string
        model:
          type: string
      type: object
    ErrorDetail:
      additionalProperties: false
      properties:
        location:
          description: >-
            Where the error occurred, e.g. 'body.items[3].tags' or
            'path.thing-id'
          type: string
        message:
          description: Error message text
          type: string
        value:
          description: The value at the given location
      type: object
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: Opaque
      description: Bearer token via Authorization header

````